diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/utils/check-style-clang-format.py ns-3.41/utils/check-style-clang-format.py
--- ns-3.40/utils/check-style-clang-format.py	2023-09-27 13:30:37.934840000 -0700
+++ ns-3.41/utils/check-style-clang-format.py	2024-02-09 14:44:08.629795300 -0800
@@ -572,151 +520,242 @@
 
     is_file_compliant = True
     verbose_infos: List[str] = []
+    clang_format_enabled = True
 
-    with open(filename, 'r', encoding='utf-8') as f:
+    with open(filename, "r", encoding="utf-8") as f:
         file_lines = f.readlines()
 
-    # Check if there are trailing whitespace and fix them
-    for (i, line) in enumerate(file_lines):
-        line_fixed = line.rstrip() + '\n'
-
-        if line_fixed == line:
-            continue
-
-        is_file_compliant = False
-        file_lines[i] = line_fixed
-
-        if verbose:
-            line_fixed_stripped_expanded = line_fixed.rstrip().expandtabs(TAB_SIZE)
-
-            verbose_infos.extend([
-                f'{filename}:{i + 1}:{len(line_fixed_stripped_expanded) + 1}: error: Trailing whitespace detected',
-                f'    {line_fixed_stripped_expanded}',
-                f'    {"":{len(line_fixed_stripped_expanded)}}^',
-            ])
-
-        # Optimization: If running in non-verbose check mode, only one error is needed to check that the file is not compliant
-        if not fix and not verbose:
-            break
+    for i, line in enumerate(file_lines):
+        # Check clang-format guards
+        if respect_clang_format_guards:
+            line_stripped = line.strip()
+
+            if line_stripped == CLANG_FORMAT_GUARD_ON:
+                clang_format_enabled = True
+            elif line_stripped == CLANG_FORMAT_GUARD_OFF:
+                clang_format_enabled = False
+
+            if not clang_format_enabled and line_stripped not in (
+                CLANG_FORMAT_GUARD_ON,
+                CLANG_FORMAT_GUARD_OFF,
+            ):
+                continue
+
+        # Check if the line is compliant with the style and fix it
+        (is_line_compliant, line_fixed, line_verbose_infos) = check_style_line_function(
+            line, filename, i
+        )
+
+        if not is_line_compliant:
+            is_file_compliant = False
+            file_lines[i] = line_fixed
+            verbose_infos.extend(line_verbose_infos)
+
+            # Optimization: If running in non-verbose check mode, only one error is needed to check that the file is not compliant
+            if not fix and not verbose:
+                break
 
     # Update file with the fixed lines
     if fix and not is_file_compliant:
-        with open(filename, 'w', encoding='utf-8') as f:
+        with open(filename, "w", encoding="utf-8") as f:
             f.writelines(file_lines)
 
     return (filename, is_file_compliant, verbose_infos)
 
 
-def check_tabs_file(filename: str,
-                    fix: bool,
-                    verbose: bool,
-                    ) -> Tuple[str, bool, List[str]]:
+def check_include_prefixes_line(
+    line: str,
+    filename: str,
+    line_number: int,
+) -> Tuple[bool, str, List[str]]:
     """
-    Check / fix tabs in a file.
+    Check / fix #include headers from the same module with the "ns3/" prefix in a line.
 
+    @param line The line to check.
     @param filename Name of the file to be checked.
-    @param fix Whether to fix (True) or just check (False) the style of the file (True).
-    @param verbose Show the lines that are not compliant with the style.
-    @return Tuple [Filename,
-                   Whether the file is compliant with the style (before the check),
+    @param line_number The number of the line checked.
+    @return Tuple [Whether the line is compliant with the style (before the check),
+                   Fixed line,
                    Verbose information].
     """
 
-    is_file_compliant = True
-    clang_format_enabled = True
+    is_line_compliant = True
+    line_fixed = line
+    verbose_infos: List[str] = []
+
+    # Check if the line is an #include and extract its header file
+    line_stripped = line.strip()
+    header_file = re.findall(r'^#include ["<]ns3/(.*\.h)[">]', line_stripped)
+
+    if header_file:
+        # Check if the header file belongs to the same module and remove the "ns3/" prefix
+        header_file = header_file[0]
+        parent_path = os.path.split(filename)[0]
+
+        if os.path.exists(os.path.join(parent_path, header_file)):
+            is_line_compliant = False
+            line_fixed = (
+                line_stripped.replace(f"ns3/{header_file}", header_file)
+                .replace("<", '"')
+                .replace(">", '"')
+                + "\n"
+            )
+
+            header_index = len('#include "')
 
+            verbose_infos.extend(
+                [
+                    f'{filename}:{line_number + 1}:{header_index + 1}: error: #include headers from the same module with the "ns3/" prefix detected',
+                    f"    {line_stripped}",
+                    f'    {"":{header_index}}^',
+                ]
+            )
+
+    return (is_line_compliant, line_fixed, verbose_infos)
+
+
+def check_whitespace_line(
+    line: str,
+    filename: str,
+    line_number: int,
+) -> Tuple[bool, str, List[str]]:
+    """
+    Check / fix whitespace in a line.
+
+    @param line The line to check.
+    @param filename Name of the file to be checked.
+    @param line_number The number of the line checked.
+    @return Tuple [Whether the line is compliant with the style (before the check),
+                   Fixed line,
+                   Verbose information].
+    """
+
+    is_line_compliant = True
+    line_fixed = line.rstrip() + "\n"
     verbose_infos: List[str] = []
 
-    with open(filename, 'r', encoding='utf-8') as f:
-        file_lines = f.readlines()
+    if line_fixed != line:
+        is_line_compliant = False
+        line_fixed_stripped_expanded = line_fixed.rstrip().expandtabs(TAB_SIZE)
 
-    for (i, line) in enumerate(file_lines):
+        verbose_infos = [
+            f"{filename}:{line_number + 1}:{len(line_fixed_stripped_expanded) + 1}: error: Trailing whitespace detected",
+            f"    {line_fixed_stripped_expanded}",
+            f'    {"":{len(line_fixed_stripped_expanded)}}^',
+        ]
 
-        # Check clang-format guards
-        line_stripped = line.strip()
+    return (is_line_compliant, line_fixed, verbose_infos)
 
-        if line_stripped == CLANG_FORMAT_GUARD_ON:
-            clang_format_enabled = True
-        elif line_stripped == CLANG_FORMAT_GUARD_OFF:
-            clang_format_enabled = False
-
-        if (not clang_format_enabled and
-                line_stripped not in (CLANG_FORMAT_GUARD_ON, CLANG_FORMAT_GUARD_OFF)):
-            continue
-
-        # Check if there are tabs and fix them
-        tab_index = line.find('\t')
-
-        if tab_index == -1:
-            continue
-
-        is_file_compliant = False
-        file_lines[i] = line.expandtabs(TAB_SIZE)
-
-        if verbose:
-            verbose_infos.extend([
-                f'{filename}:{i + 1}:{tab_index + 1}: error: Tab detected',
-                f'    {line.rstrip()}',
-                f'    {"":{tab_index}}^',
-            ])
-
-        # Optimization: If running in non-verbose check mode, only one error is needed to check that the file is not compliant
-        if not fix and not verbose:
-            break
 
-    # Update file with the fixed lines
-    if fix and not is_file_compliant:
-        with open(filename, 'w', encoding='utf-8') as f:
-            f.writelines(file_lines)
+def check_tabs_line(
+    line: str,
+    filename: str,
+    line_number: int,
+) -> Tuple[bool, str, List[str]]:
+    """
+    Check / fix tabs in a line.
 
-    return (filename, is_file_compliant, verbose_infos)
+    @param line The line to check.
+    @param filename Name of the file to be checked.
+    @param line_number The number of the line checked.
+    @return Tuple [Whether the line is compliant with the style (before the check),
+                   Fixed line,
+                   Verbose information].
+    """
+
+    is_line_compliant = True
+    line_fixed = line
+    verbose_infos: List[str] = []
+
+    tab_index = line.find("\t")
+
+    if tab_index != -1:
+        is_line_compliant = False
+        line_fixed = line.expandtabs(TAB_SIZE)
+
+        verbose_infos = [
+            f"{filename}:{line_number + 1}:{tab_index + 1}: error: Tab detected",
+            f"    {line.rstrip()}",
+            f'    {"":{tab_index}}^',
+        ]
+
+    return (is_line_compliant, line_fixed, verbose_infos)
 
 
 ###########################################################
 # MAIN
 ###########################################################
-if __name__ == '__main__':
-
+if __name__ == "__main__":
     parser = argparse.ArgumentParser(
-        description='Check and apply the ns-3 coding style to all files in a given PATH. '
-        'The script checks the formatting of the file with clang-format. '
+        description="Check and apply the ns-3 coding style recursively to all files in the given PATHs. "
+        "The script checks the formatting of the file with clang-format. "
         'Additionally, it checks #include headers from the same module with the "ns3/" prefix, '
-        'the presence of trailing whitespace and tabs. '
+        "the presence of trailing whitespace and tabs. "
         'Formatting, local #include "ns3/" prefixes and tabs checks respect clang-format guards. '
         'When used in "check mode" (default), the script checks if all files are well '
-        'formatted and do not have trailing whitespace nor tabs. '
-        'If it detects non-formatted files, they will be printed and this process exits with a '
-        'non-zero code. When used in "fix mode", this script automatically fixes the files.')
+        "formatted and do not have trailing whitespace nor tabs. "
+        "If it detects non-formatted files, they will be printed and this process exits with a "
+        'non-zero code. When used in "fix mode", this script automatically fixes the files.'
+    )
 
-    parser.add_argument('path', action='store', type=str,
-                        help='Path to the files to check')
+    parser.add_argument(
+        "paths",
+        action="store",
+        type=str,
+        nargs="+",
+        help="List of paths to the files to check",
+    )
 
-    parser.add_argument('--no-include-prefixes', action='store_true',
-                        help='Do not check / fix #include headers from the same module with the "ns3/" prefix')
+    parser.add_argument(
+        "--no-include-prefixes",
+        action="store_true",
+        help='Do not check / fix #include headers from the same module with the "ns3/" prefix',
+    )
 
-    parser.add_argument('--no-formatting', action='store_true',
-                        help='Do not check / fix code formatting')
+    parser.add_argument(
+        "--no-formatting",
+        action="store_true",
+        help="Do not check / fix code formatting",
+    )
 
-    parser.add_argument('--no-whitespace', action='store_true',
-                        help='Do not check / fix trailing whitespace')
+    parser.add_argument(
+        "--no-whitespace",
+        action="store_true",
+        help="Do not check / fix trailing whitespace",
+    )
 
-    parser.add_argument('--no-tabs', action='store_true',
-                        help='Do not check / fix tabs')
+    parser.add_argument(
+        "--no-tabs",
+        action="store_true",
+        help="Do not check / fix tabs",
+    )
 
-    parser.add_argument('--fix', action='store_true',
-                        help='Fix coding style issues detected in the files')
+    parser.add_argument(
+        "--fix",
+        action="store_true",
+        help="Fix coding style issues detected in the files",
+    )
 
-    parser.add_argument('-v', '--verbose', action='store_true',
-                        help='Show the lines that are not well-formatted')
+    parser.add_argument(
+        "-v",
+        "--verbose",
+        action="store_true",
+        help="Show the lines that are not well-formatted",
+    )
 
-    parser.add_argument('-j', '--jobs', type=int, default=max(1, os.cpu_count() - 1),
-                        help='Number of parallel jobs')
+    parser.add_argument(
+        "-j",
+        "--jobs",
+        type=int,
+        default=max(1, os.cpu_count() - 1),
+        help="Number of parallel jobs",
+    )
 
     args = parser.parse_args()
 
     try:
         all_checks_successful = check_style_clang_format(
-            path=args.path,
+            paths=args.paths,
             enable_check_include_prefixes=(not args.no_include_prefixes),
             enable_check_formatting=(not args.no_formatting),
             enable_check_whitespace=(not args.no_whitespace),
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/utils/CMakeLists.txt ns-3.41/utils/CMakeLists.txt
--- ns-3.40/utils/CMakeLists.txt	2023-09-27 13:30:37.934840000 -0700
+++ ns-3.41/utils/CMakeLists.txt	2024-02-09 14:44:08.629795300 -0800
@@ -33,13 +33,11 @@
 
     if(${NS3_MONOLIB})
       target_link_libraries(
-        test-runner ${LIB_AS_NEEDED_PRE} ${ns3-libs-tests} ${LIB_AS_NEEDED_POST}
-        ${lib-ns3-monolib} ${ns3-contrib-libs}
+        test-runner ${LIB_AS_NEEDED_PRE} ${ns3-libs-tests} ${lib-ns3-monolib} ${ns3-contrib-libs} ${LIB_AS_NEEDED_POST}
       )
     else()
       target_link_libraries(
-        test-runner ${LIB_AS_NEEDED_PRE} ${ns3-libs-tests} ${LIB_AS_NEEDED_POST}
-        ${ns3-libs} ${ns3-contrib-libs}
+        test-runner ${LIB_AS_NEEDED_PRE} ${ns3-libs-tests} ${ns3-libs} ${ns3-contrib-libs} ${LIB_AS_NEEDED_POST}
       )
     endif()
   endif()
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/utils/codespell-ignored-lines ns-3.41/utils/codespell-ignored-lines
--- ns-3.40/utils/codespell-ignored-lines	2023-09-27 13:30:37.934840000 -0700
+++ ns-3.41/utils/codespell-ignored-lines	2024-02-09 14:44:08.629795300 -0800
@@ -33,8 +33,8 @@
     echo "$filterin"
 
 #./src/visualizer/visualizer/hud.py:93-94
-            tbe = math.log10(dx_over_ndiv)#;   /* looking for approx. 'ndiv' divisions in a length 'dx' */
-            div = pow(10, rint(tbe))#;         /* div: power of 10 closest to dx/ndiv */
+            tbe = math.log10(dx_over_ndiv)
+            div = pow(10, rint(tbe))
 
 #./utils/tests/test-ns3.py:2944
             'convert {image} -colorspace HSI -channel b -separate +channel -scale 1x1 -format "%[fx:100*u]" info:'
@@ -49,6 +49,42 @@
                 arp_h->ar_tha);                                       // Target hardware address.
             arp_h->ar_hln = sizeof arp_h->ar_tha;                     // Hardware address length.
 
+# Names and emails
+ * Author: Manuel Requena <manuel.requena@cttc.es>
+ *   Manuel Requena <manuel.requena@cttc.es>
+ *   Dave Täht <d@taht.net>
+.. [Pal19] J. Palmei, S. Gupta, P. Imputato, J. Morton, M. Tahiliani, S. Avallone, and D. Taht, Design and Evaluation of COBALT Queue Discipline, 2019 IEEE International Symposium on Local and Metropolitan Area Networks (LANMAN), Paris, France, 2019.
+.. [Hoe18] T. Hoiland-Jørgensen, D. Taht and J. Morton, "Piece of CAKE: A Comprehensive Queue Management Solution for Home Gateways," 2018 IEEE International Symposium on Local and Metropolitan Area Networks (LANMAN), Washington, DC, USA, 2018.
+.. [Hoe16] T. Hoeiland-Joergensen, P. McKenney, D. Taht, J. Gettys and E. Dumazet, The FlowQueue-CoDel Packet Scheduler and Active Queue Management Algorithm, IETF draft.  Available online at `<https://tools.ietf.org/html/draft-ietf-aqm-fq-codel>`_
+   Morton,  Mohit P. Tahiliani, Stefano Avallone and Dave Taht (2019).
+ * Author: Jaume Nin <jnin@cttc.cat>
+ *   Jaume Nin <jnin@cttc.cat>
+ * Author: Jaume Nin <jaume.nin@cttc.cat>
+ *   Jaume Nin <jaume.nin@cttc.cat>
+ * Author: Jaume Nin <jaume.nin@cttc.es>
+ * Author: Jaume Nin <jnin@cttc.es>
+ *   Jaume Nin <jnin@cttc.es>
+ * Copyright (c) 2014 Universita' degli Studi di Napoli "Federico II"
+ *               2014 Universita' degli Studi di Napoli "Federico II"
+ * Copyright (c) 2015 Universita' degli Studi di Napoli Federico II
+ * Copyright (c) 2015 Universita' degli Studi di Napoli "Federico II"
+ *               2015 Universita' degli Studi di Napoli Federico II
+ * Copyright (c) 2016 Universita' degli Studi di Napoli Federico II
+ * Copyright (c) 2017 Universita' degli Studi di Napoli Federico II
+ *               2017 Università' degli Studi di Napoli Federico II
+ *               2017 Universita' degli Studi di Napoli Federico II
+ * Copyright (c) 2018 Universita' degli Studi di Napoli Federico II
+ * Copyright (c) 2019 Universita' degli Studi di Napoli Federico II
+ * Copyright (c) 2020 Universita' degli Studi di Napoli Federico II
+ * Copyright (c) 2021 2020 Universita' degli Studi di Napoli Federico II
+ * Copyright (c) 2021 Universita' degli Studi di Napoli Federico II
+ * Copyright (c) 2022 Universita' degli Studi di Napoli Federico II
+ * Copyright (c) 2022 Universita' degli Studi di Napoli "Federico II"
+ * Copyright (c) 2023 Universita' degli Studi di Napoli Federico II
+
+./src/core/examples/hash-example.cc
+6ed21de2  brand-newness       peripherial
+
 ./src/dsr/model/dsr-routing.cc:243, 246, 3360, 3363
             .AddAttribute("GratReplyHoldoff",
                           MakeTimeAccessor(&DsrRouting::m_gratReplyHoldoff),
@@ -83,6 +119,9 @@
 ./src/lte/model/lte-mi-error-model.h:23:
  *      for mobIlE Video AppLications) project, which is a
 
+./src/traffic-control/doc/tbf.rst:84:
+.. [Ref2] J. Vehent; Journey to the Center of the Linux Kernel: Traffic Control, Shaping and QoS; Available online at `<https://web.archive.org/web/20190930031243/http://wiki.linuxwall.info/doku.php/en:ressources:dossiers:networking:traffic_control#tbf_-_token_bucket_filter>`_.
+
 ./src/traffic-control/model/codel-queue-disc.h:17:
  * Codel, the COntrolled DELay Queueing discipline
 
@@ -117,5 +156,8 @@
   * (wifi) Enumerated value `MDAOP_ADVERTISMENTS` from `mgmt-headers.h` was renamed `MDAOP_ADVERTISEMENTS`.
   * (wifi) Define `IE_BEAMLINK_MAINENANCE` from `wifi-information-element.h` was renamed `IE_BEAMLINK_MAINTENANCE`.
   * (wimax) Attribute `m_nrRecivedFecBlocks` from `simple-ofdm-wimax-phy.h` was renamed `m_nrReceivedFecBlocks`.
+  * (lte) Struct member `fdbetsFlowPerf_t::lastTtiBytesTrasmitted` in file `fdbet-ff-mac-scheduler.h` was renamed `fdbetsFlowPerf_t::lastTtiBytesTransmitted`.
+  * (lte) Struct member `tdbetsFlowPerf_t::lastTtiBytesTrasmitted` in file `tdbet-ff-mac-scheduler.h` was renamed `fdbetsFlowPerf_t::lastTtiBytesTransmitted`.
+  * (lte) Struct member `pfsFlowPerf_t::lastTtiBytesTrasmitted` in file `pf-ff-mac-scheduler.h` was renamed `fdbetsFlowPerf_t::lastTtiBytesTransmitted`.
 * The spelling of the attribute `IntialCellVoltage` from `LiIonEnergySource` was corrected to `InitialCellVoltage`; this will affect existing users who were using the attribute with the misspelling.
 * The attribute `Recievers` in class `YansWifiPhy` was misspelled, so this has been corrected to `Receivers`.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/utils/codespell-ignored-words ns-3.41/utils/codespell-ignored-words
--- ns-3.40/utils/codespell-ignored-words	2023-09-27 13:30:37.934840000 -0700
+++ ns-3.41/utils/codespell-ignored-words	2024-02-09 14:44:08.629795300 -0800
@@ -2,81 +2,40 @@
 te
 
 #Core
-anid
-anumber
 bu
 mone
-peripherial
-studi
-thre
 
 #Network
 ot
 nd
 
 #Internet
-devicec
 ect
 iif
-nce
-inflight
-upto
-
-#Internet Apps
-clen
-
-#Buildings
-nin
 
 #DSR
-cleanp
 grat
 
 #LTE
 commun
-couting
 ue
 ues
 
-#Netanim
-writen
-
-#Spectrum
-inh
-
-#Wave
-aci
-ois
-
-#Wifi
-fo
-
 #Traffic Control
-taht
 interm
 
+#Wi-Fi
+aci
+
 #Wimax
 aas
 opps
 
-#Propagation
-alos
-clos
-
-#Examples
-clienta
-
 #Brite
 brite
 
-#Mesh
-inport
-
 #Visualizer
 inout
 
 #Utils
 filetest
-
-#test-ns3.py
-dependant
